//
const float2 origin : register(c0);

sampler scene_tex : register(s0);

struct vs_in
{
	float3 position : POSITION;
	float2 uv : TEXCOORD;
};
struct vs_out
{
	float4 position : POSITION;
	float2 uv : TEXCOORD;
};

vs_out VS(vs_in _in)
{
	vs_out _out;
	_out.position = float4(_in.position, 1);
	_out.uv = _in.uv;
	return _out;
}

static const int SAMPLES = 80;
static const float exposure = 2.5 * (1.0 / SAMPLES); //0.04;

float4 PS(vs_out _in) : COLOR
{
	float2 ray = origin - _in.uv;
	float2 dr = ray / SAMPLES * 1.0;
	float2 uv = _in.uv;//origin;
	float3 c = 0;
	for(int i = 0; i < SAMPLES; ++i)
	{
		c += tex2D(scene_tex, uv).rgb;
		uv += dr;
	}
	c *= (1 - length(ray) * 0.4) * exposure;
	c += tex2D(scene_tex, _in.uv).rgb;
	return float4(c, 1);
}
