//
const float4x4 world : register(c0);
const float4x4 camera_view_proj : register(c4);

sampler tex : register(s0);

struct vs_in
{
	float3 position : POSITION;
};
struct vs_out
{
	float4 position : POSITION;
	float3 uvw : TEXCOORD;
};

vs_out VS(vs_in _in)
{
	vs_out _out;
	float4 pos_world = mul(float4(_in.position, 1), world);
	_out.position = mul(pos_world, camera_view_proj);
	_out.uvw = _in.position;
	return _out;
}

float4 PS(vs_out _in) : COLOR
{
	return texCUBE(tex, _in.uvw);
}
